%{
#define YYSTYPE double

#include <stdio.h>
#include <stdlib.h>
#include "calc.tab.h"

void yyerror(char* msg);
extern int yylex();
%}

%token NUMBER
%token QUIT


%%

list:
	| list '\n'
	| list expr '\n'			{ printf("%f\n", $2); }
	;
	
expr: NUMBER					{ $$ = $1; }
	| expr '+' expr				{ $$ = $1 + $3; }
	| expr '-' expr				{ $$ = $1 - $3; }
	| expr '*' expr				{ $$ = $1 * $3; }
	| expr '/' expr				{ $$ = $1 / $3; }
	| '-' expr 	           		{ $$ = -$2; }
	| '(' expr ')'				{ $$ = $2; }
    | QUIT  					{ printf("leaving ...\n"); exit(0); }
    ;

%%

int main() {
	return yyparse();
}

void yyerror(char* msg) {
	fprintf(stderr, "ERROR: %s\n", msg);
	exit(-1);
}
